<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DataNode.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">DataNode.java</span></div><h1>DataNode.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;
import java.util.Collections;

import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.data.StatPersisted;

/**
 * This class contains the data for a node in the data tree.
 * &lt;p&gt;
 * A data node contains a reference to its parent, a byte array as its data, an
 * array of ACLs, a stat object, and a set of its children's paths.
 * 
 */
public class DataNode implements Record {
    /** the parent of this datanode */
    DataNode parent;

    /** the data for this datanode */
    byte data[];

    /**
     * the acl map long for this datanode. the datatree has the map
     */
    Long acl;

    /**
     * the stat for this node that is persisted to disk.
     */
    public StatPersisted stat;

    /**
     * the list of children for this node. note that the list of children string
     * does not contain the parent path -- just the last part of the path. This
     * should be synchronized on except deserializing (for speed up issues).
     */
<span class="fc" id="L61">    private Set&lt;String&gt; children = null;</span>

    /**
     * default constructor for the datanode
     */
<span class="fc" id="L66">    DataNode() {</span>
        // default constructor
<span class="fc" id="L68">    }</span>

    /**
     * create a DataNode with parent, data, acls and stat
     * 
     * @param parent
     *            the parent of this DataNode
     * @param data
     *            the data to be set
     * @param acl
     *            the acls for this node
     * @param stat
     *            the stat for this node.
     */
<span class="fc" id="L82">    public DataNode(DataNode parent, byte data[], Long acl, StatPersisted stat) {</span>
<span class="fc" id="L83">        this.parent = parent;</span>
<span class="fc" id="L84">        this.data = data;</span>
<span class="fc" id="L85">        this.acl = acl;</span>
<span class="fc" id="L86">        this.stat = stat;</span>
<span class="fc" id="L87">    }</span>

    /**
     * Method that inserts a child into the children set
     * 
     * @param child
     *            to be inserted
     * @return true if this set did not already contain the specified element
     */
    public synchronized boolean addChild(String child) {
<span class="fc bfc" id="L97" title="All 2 branches covered.">        if (children == null) {</span>
            // let's be conservative on the typical number of children
<span class="fc" id="L99">            children = new HashSet&lt;String&gt;(8);</span>
        }
<span class="fc" id="L101">        return children.add(child);</span>
    }

    /**
     * Method that removes a child from the children set
     * 
     * @param child
     * @return true if this set contained the specified element
     */
    public synchronized boolean removeChild(String child) {
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">        if (children == null) {</span>
<span class="nc" id="L112">            return false;</span>
        }
<span class="fc" id="L114">        return children.remove(child);</span>
    }

    /**
     * convenience method for setting the children for this datanode
     * 
     * @param children
     */
    public synchronized void setChildren(HashSet&lt;String&gt; children) {
<span class="fc" id="L123">        this.children = children;</span>
<span class="fc" id="L124">    }</span>

    /**
     * convenience methods to get the children
     * 
     * @return the children of this datanode
     */
    public synchronized Set&lt;String&gt; getChildren() {
<span class="fc bfc" id="L132" title="All 2 branches covered.">        if (children == null) {</span>
<span class="fc" id="L133">            return children;</span>
        }

<span class="fc" id="L136">        return Collections.unmodifiableSet(children);</span>
    }

    synchronized public void copyStat(Stat to) {
<span class="fc" id="L140">        to.setAversion(stat.getAversion());</span>
<span class="fc" id="L141">        to.setCtime(stat.getCtime());</span>
<span class="fc" id="L142">        to.setCzxid(stat.getCzxid());</span>
<span class="fc" id="L143">        to.setMtime(stat.getMtime());</span>
<span class="fc" id="L144">        to.setMzxid(stat.getMzxid());</span>
<span class="fc" id="L145">        to.setPzxid(stat.getPzxid());</span>
<span class="fc" id="L146">        to.setVersion(stat.getVersion());</span>
<span class="fc" id="L147">        to.setEphemeralOwner(stat.getEphemeralOwner());</span>
<span class="fc bfc" id="L148" title="All 2 branches covered.">        to.setDataLength(data == null ? 0 : data.length);</span>
<span class="fc" id="L149">        int numChildren = 0;</span>
<span class="fc bfc" id="L150" title="All 2 branches covered.">        if (this.children != null) {</span>
<span class="fc" id="L151">            numChildren = children.size();</span>
        }
        // when we do the Cversion we need to translate from the count of the creates
        // to the count of the changes (v3 semantics)
        // for every create there is a delete except for the children still present
<span class="fc" id="L156">        to.setCversion(stat.getCversion()*2 - numChildren);</span>
<span class="fc" id="L157">        to.setNumChildren(numChildren);</span>
<span class="fc" id="L158">    }</span>

    synchronized public void deserialize(InputArchive archive, String tag)
            throws IOException {
<span class="fc" id="L162">        archive.startRecord(&quot;node&quot;);</span>
<span class="fc" id="L163">        data = archive.readBuffer(&quot;data&quot;);</span>
<span class="fc" id="L164">        acl = archive.readLong(&quot;acl&quot;);</span>
<span class="fc" id="L165">        stat = new StatPersisted();</span>
<span class="fc" id="L166">        stat.deserialize(archive, &quot;statpersisted&quot;);</span>
<span class="fc" id="L167">        archive.endRecord(&quot;node&quot;);</span>
<span class="fc" id="L168">    }</span>

    synchronized public void serialize(OutputArchive archive, String tag)
            throws IOException {
<span class="fc" id="L172">        archive.startRecord(this, &quot;node&quot;);</span>
<span class="fc" id="L173">        archive.writeBuffer(data, &quot;data&quot;);</span>
<span class="fc" id="L174">        archive.writeLong(acl, &quot;acl&quot;);</span>
<span class="fc" id="L175">        stat.serialize(archive, &quot;statpersisted&quot;);</span>
<span class="fc" id="L176">        archive.endRecord(this, &quot;node&quot;);</span>
<span class="fc" id="L177">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>